
module.exports.stopFlowFromRequest = function stopFlowFromRequest(roadie) {

    var TemplateModel = null,
        FlowsModel = null;

    return function stopFlow(req, res) {

          roadie.cache.get('userPasses', req.user.userId, null, function (err, userPasses) {

            if (err) {
                res.status(500).send(err);
            }
            else {

                var flowId = req.params.flowId;

                roadie.FlowsModel.findById(
                    flowId,
                    function(err, flowDoc) {
                        if (err) {
                            res.status(500).send(err);
                        }
                        else {
                            if (flowDoc) {

                                if (userPasses.canStopFlow(flowDoc.templateId)) {

                                    flowDoc.remove(function(err) {
                                        if (err) {
                                            res.status(500).send(err);
                                        }
                                        else {
                                            res.status(200).send();
                                        }
                                    });
                                }
                                else {
                                    res.status(403).send(
                                        {
                                            name: 'noStop',
                                            message: 'User has no pass to stop flow ' + flowId
                                        }
                                    );
                                }



                            }
                            else {
                                res.status(404).send(
                                    {
                                        name: 'noFlow',
                                        message: 'Unable to find flow with id ' + flowId
                                    }
                                );
                            }
                        }
                    }
                );

//                if (userPasses.canStopFlow(req.body.templateId)) {

//                    res.status(200).send();

                    //generateFlowDoc(
                    //    TemplateModel,
                    //    FlowsModel,
                    //    req.user.username,
                    //    req.body.templateId,
                    //    req.body.params,
                    //    function(err, flowDoc) {
                    //
                    //        if (err) {
                    //            res.status(err.status).send(err.error);
                    //        }
                    //        else {
                    //            progressFlow(roadie, true, flowDoc, req.body.templateId, req.body.params, req.body.username, res);
                    //        }
                    //
                    //
                    //    }
                    //);
                //}
                //else {
                //    res.status(404).send("Hmmmm"+JSON.stringify(req.body.flowId)+'...');
                //}

            }
        });
    }
};